import { Injectable, OnModuleInit } from '@nestjs/common';
import { Client, GatewayIntentBits } from 'discord.js';

@Injectable()
export class DiscordService implements OnModuleInit {
  private readonly client: Client;

  constructor() {
    this.client = new Client({
      intents: [
        GatewayIntentBits.Guilds,
        GatewayIntentBits.GuildVoiceStates,
        GatewayIntentBits.GuildMessages,
        GatewayIntentBits.GuildMessageReactions,
        GatewayIntentBits.MessageContent,
      ],
    });
  }

  async onModuleInit() {
    console.log('Starting Discord bot...');
    await this.client.login(process.env.DISCORD_ENV);

    this.client.on('ready', () => {
      console.log('Discord bot is online!');
    });

    this.client.on('messageCreate', async (message) => {
      if (!message.content.startsWith('!') || message.author.bot) return;

      const args = message.content.slice(1).trim().split(/ +/);
      const command = args.shift()?.toLowerCase();

      if (command === 'test') {
        await message.reply('Test command executed!');
      }
    });
  }
}